/*
 * This file is generated by jOOQ.
*/
package com.tabajara.base.tables.interfaces;


import io.github.jklingsporn.vertx.jooq.shared.internal.VertxPojo;

import java.io.Serializable;

import javax.annotation.Generated;


/**
 * This class is generated by jOOQ.
 */
@Generated(
    value = {
        "http://www.jooq.org",
        "jOOQ version:3.10.5"
    },
    comments = "This class is generated by jOOQ"
)
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public interface IUsuarios extends VertxPojo, Serializable {

    /**
     * Setter for <code>public.usuarios.usuid</code>.
     */
    public IUsuarios setUsuid(Integer value);

    /**
     * Getter for <code>public.usuarios.usuid</code>.
     */
    public Integer getUsuid();

    /**
     * Setter for <code>public.usuarios.usunome</code>.
     */
    public IUsuarios setUsunome(String value);

    /**
     * Getter for <code>public.usuarios.usunome</code>.
     */
    public String getUsunome();

    /**
     * Setter for <code>public.usuarios.ususenha</code>.
     */
    public IUsuarios setUsusenha(String value);

    /**
     * Getter for <code>public.usuarios.ususenha</code>.
     */
    public String getUsusenha();

    /**
     * Setter for <code>public.usuarios.usuativo</code>.
     */
    public IUsuarios setUsuativo(String value);

    /**
     * Getter for <code>public.usuarios.usuativo</code>.
     */
    public String getUsuativo();

    /**
     * Setter for <code>public.usuarios.fkfunmatricula</code>.
     */
    public IUsuarios setFkfunmatricula(String value);

    /**
     * Getter for <code>public.usuarios.fkfunmatricula</code>.
     */
    public String getFkfunmatricula();

    /**
     * Setter for <code>public.usuarios.fkgrpid</code>.
     */
    public IUsuarios setFkgrpid(Integer value);

    /**
     * Getter for <code>public.usuarios.fkgrpid</code>.
     */
    public Integer getFkgrpid();

    // -------------------------------------------------------------------------
    // FROM and INTO
    // -------------------------------------------------------------------------

    /**
     * Load data from another generated Record/POJO implementing the common interface IUsuarios
     */
    public void from(com.tabajara.base.tables.interfaces.IUsuarios from);

    /**
     * Copy data into another generated Record/POJO implementing the common interface IUsuarios
     */
    public <E extends com.tabajara.base.tables.interfaces.IUsuarios> E into(E into);

    @Override
    public default IUsuarios fromJson(io.vertx.core.json.JsonObject json) {
        setUsuid(json.getInteger("usuid"));
        setUsunome(json.getString("usunome"));
        setUsusenha(json.getString("ususenha"));
        setUsuativo(json.getString("usuativo"));
        setFkfunmatricula(json.getString("fkfunmatricula"));
        setFkgrpid(json.getInteger("fkgrpid"));
        return this;
    }


    @Override
    public default io.vertx.core.json.JsonObject toJson() {
        io.vertx.core.json.JsonObject json = new io.vertx.core.json.JsonObject();
        json.put("usuid",getUsuid());
        json.put("usunome",getUsunome());
        json.put("ususenha",getUsusenha());
        json.put("usuativo",getUsuativo());
        json.put("fkfunmatricula",getFkfunmatricula());
        json.put("fkgrpid",getFkgrpid());
        return json;
    }

}
